

  $regfile = "m328pdef.dat"       '  
  $crystal = 1000000       ' 1 
  $framesize = 32   '      
  $hwstack = 40     '   
  $swstack = 16     '   


  $baud = 4800      '4800     '19200     '38400     '57600     '76800     '115200    '230400
  Ucsr0a.1 = 1      '    USART,   = $baud * 2
  Print "Reset "
'  Wait 1

  Wdtcsr = &B00011000       '  ,  Watchdog
'            ||||||||
'            |||||||+- 0 - WDP0 -   Watchdog   11-2    , .55-56
'            ||||||+-- 1 - WDP1 -   Watchdog   11-2    , .55-56
'            |||||+--- 2 - WDP2 -   Watchdog   11-2    , .55-56
'            ||||+---- 3 - WDE  - Watchdog  
'            |||+----- 4 - WDCE - Watchdog  Change Enable
'            ||+------ 5 - WDP3 -   Watchdog   11-2    , .55-56
'            |+------- 6 - WDIE - Watchdog  
'            +-------- 7 - WDIF - Watchdog    
' :


  Wdtcsr = &B01100001       '  ,  Watchdog
'            ||||||||
'            |||||||+- 0 - WDP0 -   Watchdog   11-2    , .55-56
'            ||||||+-- 1 - WDP1 -   Watchdog   11-2    , .55-56
'            |||||+--- 2 - WDP2 -   Watchdog   11-2    , .55-56
'            ||||+---- 3 - WDE  - Watchdog  
'            |||+----- 4 - WDCE - Watchdog  Change Enable
'            ||+------ 5 - WDP3 -   Watchdog   11-2    , .55-56
'            |+------- 6 - WDIE - Watchdog  
'            +-------- 7 - WDIF - Watchdog    
' :

  wdr

'Table 11-2. Watchdog Timer Prescale Select

' WDP3 WDP2 WDP1 WDP0   Number of WDT Oscillator Cycles     Typical Time-out at VCC= 5.0V
'   0    0    0    0            2K (2048)                          cycles 16ms
'   0    0    0    1            4K (4096)                          cycles 32ms
'   0    0    1    0            8K (8192)                          cycles 64ms
'   0    0    1    1           16K (16384)                         cycles 0.125 s
'   0    1    0    0           32K (32768)                         cycles 0.25 s
'   0    1    0    1           64K (65536)                         cycles 0.5 s
'   0    1    1    0          128K (131072)                        cycles 1.0 s
'   0    1    1    1          256K (262144)                        cycles 2.0 s
'   1    0    0    0          512K (524288)                        cycles 4.0 s
'   1    0    0    1         1024K (1048576)                       cycles 8.0 s
'   1    0    1    0         Reserved
'   1    0    1    1         Reserved
'   1    1    0    0         Reserved
'   1    1    0    1         Reserved
'   1    1    1    0         Reserved
'   1    1    1    1         Reserved

'Table 11-1. Watchdog Timer Configuration
' WDTON WDE WDIE                Mode                   Action on Time-out
'   1    0    0               Stopped                       None
'   1    0    1          Interrupt Mode                     Interrupt
'   1    1    0           System Reset                      Mode Reset
'   1    1    1    Interrupt and System Reset Mode       Interrupt, then go to System Reset Mode
'   0    x    x        System Reset Mode                     Reset

' $asm


  On Utxc __usart_ Nosave       '       ,     USART
  On Wdt __watchdog Nosave       '        - Watchdog


  Dim  As Byte
  Dim __watchdog As Byte
  Dim __ As Byte : __ = 1


'  Config Watchdog = 4096
'  Start Watchdog
'  Reset Watchdog


  Enable Wdt
  Enable Utxc
  Enable Interrupts

'  Reset Watchdog

'===============================================================================
'                                     
'===============================================================================
  _:



    If __watchdog <> 0 Then
        __watchdog = 0
        Print 
    End If


'    Wait 2
'    If __ <> 0 Then

        Idle

'        __ = 0

        'Powerdown
'    End If



  Goto _
 End
'===============================================================================
'                                   
'===============================================================================



'===============================================================================
  __watchdog:
'-------------------------------------------------------------------------------
    $asm
      Push R30
      In R30 , Sreg
      Push R30
      push R31

      lds R30 , {}
      inc R30
      sts {} , R30

      ldi R30 , 1
      sts {__Watchdog} , R30


'      wdr

      ldi R30 , &B00011000
      sts Wdtcsr , R30

      ldi R30 , &B01100001
      sts Wdtcsr , R30

'      wdr

      pop R31
      pop R30
      Out Sreg , R30       '   ,   , 2 
      Pop R30

      reti
    $end Asm
'-------------------------------------------------------------------------------
  Return
'===============================================================================




'===============================================================================
  __usart_:
'-------------------------------------------------------------------------------
    $asm
      push R16

      ldi R16 , 1
      sts {__} , R16

      pop R16
      reti
    $end Asm
'-------------------------------------------------------------------------------
  Return
'===============================================================================